package WebFlow.QS;

import WebFlow.event.*;
import WebFlow.*;
import java.util.*;
import java.io.*;
import java.net.*;
import org.omg.CORBA.*;

public class FileBrowserImp extends WebFlow.BeanContextChildSupport
    implements FileBrowserOperations, WebFlowModule {

String msg_;
org.omg.CORBA.Object peer;
PropertyChangeSupport pcs;
VetoableChangeSupport vcs;
WFFileDescriptor outFile;

public FileBrowserImp(org.omg.CORBA.Object peer, String msg)
   throws WebFlow.NullPointerException
  {
    super(peer);	
    msg_ = msg;
    pcs = new PropertyChangeSupport(peer,this);
    vcs = new VetoableChangeSupport(peer,this);
    this.peer = peer;
    outFile = new WFFileDescriptorImpl(peer);
  }

  public void setFileName(String dirName) {
    String newmessage = dirName;
    
    outFile.setFileAttribute("default");   
    outFile.setFileHost("local");    

    System.out.println("FileBrowser: create outFile with "+newmessage);
    int  idx=newmessage.lastIndexOf(File.separator);
    outFile.setFileName(newmessage.substring(idx+1));
    System.out.println("FileBrowser: file name "+outFile.getFileName());
    outFile.setFileDirectory(newmessage.substring(0,idx+1));
    System.out.println("FileBrowser: directory "+outFile.getFileDirectory());


    /*    if(outFile.getFileDirectory().lastIndexOf("GAUSSIAN")>0) {
      outFile.setFileAttribute("GAUSSIAN");
    }
    if(outFile.getFileDirectory().lastIndexOf("GAMESS")>0) {
      outFile.setFileAttribute("GAMESS");
    }
    if(outFile.getFileDirectory().lastIndexOf("CERIUS2")>0) {
      outFile.setFileAttribute("CERIUS2");
    }
    if(outFile.getFileDirectory().lastIndexOf("GAUS2PDB")>0) {
      outFile.setFileAttribute("GAUS2PDB");
    }
    */
    System.out.println("FileBrowser:send outFile with "+outFile.getFileName());
    //send through output Port
    //outport.send(outFile); 
    pcs.fireEvent("Event101",outFile);
  }

    public void run() {
      System.out.println("FileBrowserImp: Run called");
    }  

    public void Method1() {
	// input port 1
      System.out.println("FileBrowserImp: input port 1 not supported");
    }

    public void Method2() {
      System.out.println("FileBrowserImp: input port 2 not supported");
    }    

    public void Method3() {
      System.out.println("FileBrowserImp: input port 3 not supported");
    }    

  public String[] refreshDirectory(String dirName)
  {
    System.out.println("refreshDirectory is CALLED with:"+dirName);
    String[] directory_contents=null;
    String dir = dirName;
    try{
      directory_contents = list(dir,"");
    }catch(InterruptedException e){
      System.out.println("InterruptedException in list of directory content:"+e);
    }
    return  directory_contents;
  }
public   String [] list(String dir,String opts)
         throws InterruptedException
  {
    String[] FileList,returnValue;
    Vector lines = new Vector();
    lines.addElement(dir);

    File file = new File(dir);

    if(file.exists()) {
	if(file.isDirectory()) {
	    if(file.canRead()) {
                 FileList = file.list();
                 lines.addElement("total xx");
                 for(int ifile=0;ifile<FileList.length;ifile++) {
                     if((new File(dir,FileList[ifile])).isDirectory()) {
                         lines.addElement("<DIR> "+FileList[ifile]);
		     }
                     else {
                         lines.addElement(FileList[ifile]);
		     }
		 }
	    }
	    else {
               System.out.println(dir+" is not readable");
               lines.addElement("total xx");
               lines.addElement(dir+" is not readable");
	    }
	}
	else {
           System.err.println(dir+" is not a directory");
           lines.addElement("total xx");
           lines.addElement(dir+"is not a directory");
	}
    } 
    else {
      System.err.println("directory "+dir+" does not exists");
      lines.addElement("total xx");
      lines.addElement(dir+"does not exists");
    }

    returnValue = new String[lines.size()];
    lines.copyInto(returnValue);
    return returnValue;

    /*
    //insert first requested directory name
    lines.addElement(dir);

    String separator = File.separator;
    boolean isExist=false,isRead=false,isDir;
    Vector lines = new Vector();
    //check that this directory exists first

    try{
      if (file.exists())
	isExist = true;
      isRead = file.canRead();

    }catch(SecurityException e){
      System.out.println("Security Exception "+e);
    }
    
    if (!isRead){
      System.out.println(dir+" is not readable");
      lines.addElement("total xx");  
      lines.addElement("NotReadable");
    }
    else if (!isExist){
      System.out.println(dir+" Not Found");
      lines.addElement("total xx");
      lines.addElement("NotFound");
    }

    if ((!isRead)||(!isExist)){
      System.out.println("file "+dir+" not found or not readable");
      String[] retval = new String[lines.size()];
      lines.copyInto(retval);
      return retval;
    }

    try{
      String line;
      String  cmd=null,pwd=null;
      Process child;
      DataInputStream in;

      //start up the command
	if (separator.equals("/")) //UNIX
        cmd = "ls -al "+dir;
      else if (separator.equals("\\")) //WIN/NT
	  cmd = "cmd.exe /C "+" DIR "+dir;   //running dir on top of WIN/NT
        //cmd = "command.com /C "+" DIR "+dir; //running dir on top of DOS
      child = Runtime.getRuntime().exec(cmd);
	System.out.println("Before DIS ");
      in = new DataInputStream(child.getInputStream());
     
      //read the command's output
      while((line = in.readLine()) != null){
 	    lines.addElement(line);
          System.out.println("line: "+line);
      }
	//User gave wrong directory name
	if (lines.size() == 0){
         System.out.println(dir+" Not Found");
         lines.addElement("total xx");
         lines.addElement("Filename ,directory name or volume label syntax is incorrect");
         String[] retval = new String[lines.size()];
         lines.copyInto(retval);
         return retval; 
	}

	// If you want to see detail , give this command "cmd /C dir " or "command /C dir"
      //Delete first three lines of output from dir command
      //Volume in drive ..; volume serial; blank line and fifth line  which is blank
	//and last three lines
      if (separator.equals("\\")){    //WIN/NT 	
	   System.out.println("Delete these (first): "+lines.elementAt(1)+"-*- "+
	                                       lines.elementAt(2)+"-*- "+
 						         lines.elementAt(3)+"-*-"+
	  						   lines.elementAt(5)+"-*-");	
	   lines.removeElementAt(1);
         lines.removeElementAt(1);
	   lines.removeElementAt(1);
         lines.removeElementAt(2);
	   int l = lines.size()-1;
	   System.out.println("Delete these (last): "+lines.elementAt(l)+"-*- "+
	                                       lines.elementAt(l-1)+"-*-");
 						         
         lines.removeElementAt(l);
         lines.removeElementAt(l-1);
	}

      String[] retval = new String[lines.size()];
      lines.copyInto(retval);
      return retval;
    } catch (Exception e){
      throw new InterruptedException (e.toString());
    }
  */
  }

  public void stop() {System.out.println("FileBrowserImp: Stop called");}
}




